# ember-cli-babel-typescript

[![Build Status](https://travis-ci.org/ClarkSource/ember-cli-babel-typescript.svg)](https://travis-ci.org/ClarkSource/ember-cli-babel-typescript)
[![npm version](https://badge.fury.io/js/%40ember-decorators%2Fbabel-transforms.svg)](https://badge.fury.io/js/%40ember-decorators%2Fbabel-transforms)
[![dependencies Status](https://david-dm.org/ClarkSource/ember-cli-babel-typescript/status.svg)](https://david-dm.org/ClarkSource/ember-cli-babel-typescript)
[![devDependencies Status](https://david-dm.org/ClarkSource/ember-cli-babel-typescript/dev-status.svg)](https://david-dm.org/ClarkSource/ember-cli-babel-typescript?type=dev)

Enables your app or addon to use [TypeScript syntax](https://www.typescriptlang.org/)
through [ember-cli-babel](https://github.com/babel/ember-cli-babel/pull/140) and
[@babel/plugin-transform-typescript](https://github.com/babel/babel/tree/master/packages/babel-plugin-transform-typescript).

## Installation

 first.

```
ember install @ClarkSource/ember-cli-babel-typescript
```

## What this does

This addon will do the following:

- install an [unreleased beta version ember-cli-babel](https://github.com/babel/ember-cli-babel/pull/140)
  that supports Babel 7
- add the required transforms
- enable transpilation of `.ts` files
- install `typescript-eslint-parser` for eslint
- remove [`@ember-decorators/babel-transforms`](https://github.com/ember-decorators/babel-transforms)
- remove `babel-eslint`

However it will *not*:

- do type checking

## Configuration

You can configure this addon in you `ember-cli-build.js` file:

```js
/* eslint-env node */
'use strict';

const EmberAddon = require('ember-cli/lib/broccoli/ember-addon');

module.exports = function(defaults) {
  const app = new EmberAddon(defaults, {
    'ember-cli-babel-typescript': {
      disable: false
    }
  });

  return app.toTree();
};
```

The only option is `disable`, which defaults to `false`. If you set `disable` to `true`, Babel will not get configured for usage with TypeScript.
